﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography.X509Certificates;
using System.Text;

namespace WifExt
{
    public class X509StoreExt
    {
        public static R Use<R>(StoreName name, StoreLocation loc, Func<X509Store, R> f)
        {
            var store = new X509Store(name, loc);
            try
            {
                store.Open(OpenFlags.OpenExistingOnly | OpenFlags.ReadOnly | OpenFlags.IncludeArchived);
                return f(store);
            }
            finally
            {
                store.Close();
            }
        }

        public static X509Certificate2 GetCertificateFromStoreBySubjectName(StoreName name, StoreLocation loc, string subject)
        {
            return X509StoreExt.Use(name, loc, s =>
                                                   {
                                                       var coll = s.Certificates.Find(X509FindType.FindBySubjectName, subject,
                                                                           false);
                                                       return coll.Count > 0 ? coll[0] : null;
                                                   });
        }
    }
}
